id: https://w3id.org/gaia-x/development#vm-image
name: vm-image
prefixes:
  gx: https://w3id.org/gaia-x/development#
  linkml: https://w3id.org/linkml/
imports:
  - device
  - image
  - resource
  - slots
default_prefix: gx
default_range: string

classes:

  VM_Image:
    is_a: Image
    title: VM image
    description: Image for virtual machines.
    slots:
      - vmImageDiskFormat
      - hypervisorType
      - firmwareType
      - hwRngTypeOfImage
      - watchDogAction
    slot_usage:
      hypervisorType:
        description: Hypervisor type required by the image
        ifabsent: HypervisorType(other)

enums:

  FirmType:
    description: Possible values for VM image's firmetype required by hypervisor.
    permissible_values:
      BIOS: null
      UEFI: null
      other: null

  WatchDogActions:
    description: Possible values for VM image's watchdog actions.
    permissible_values:
      disabled:
        description: No watchdog is enabled. No action will be performed if server
          hangs.
      reset:
        description: Restart of guest us forced if server hangs.
      poweroff:
        description: Power of of guest is forced if server hangs.
      pause:
        description: Pause of guest is forced, if server hangs.
      unavailable:
        description: Watchdog is enabled, but not action is defined and performed
          if server hangs.

  RNG_Types:
    permissible_values:
      Electrical noise:
        description: Hardware random generator is based on electronic noise.
      Chaos-based:
        description: Hardware random generator is based on chaos.
      Free-running oscillators:
        description: Hardware random generator is based in electronic free-running
          oscillators.
      Quantum:
        description: Hardware random generator is based in electronic quantum effects.
      Unavailable:
        description: No hardware random generator (RNG) is used. Entropy is taken
          from /dev/urandom.

  VM_DiskType:
    permissible_values:
      RAW: null
      QCOW2: null
      VHD: null
      VMDK: null
      ISO: null
      CVF: null
      CVA: null
